/*ModExplorer ARexx-Script*/
/*Create Playlist for AmigaAMP*/  
OPTIONS RESULTS
IF ~SHOW("PORTS",MODEXPLORER)												/*Check if ModExplorer is running*/
THEN DO
	SAY "ModExplorer is not running!!"
	EXIT																		/*Exit, if ModExplorer is not running*/
END

ADDRESS MODEXPLORER
SLEEP ON																		/*Set ModExplorers GUI to sleep*/
GUITITLE "AmigaAMP Playlist Script"												/*Set GUI title*/
GUIGAUGE 0																	/*Set gaugevalue to zero*/
GUIGAUGETITLE "Working:"														/*Set gauge title*/
GUIGAUGE OPEN																/*Open gauge*/
GUICOMMAND CLEAR															/*Clear Command list*/
GUICOMMANDTITLE "Work in progress..."											/*Set Command title*/
GUICOMMAND OPEN															/*Open Command list*/
GUI OPEN																		/*Open GUI*/
SYSTEMREQUEST "This script creates a complet Playlist for AmigaAMP!" "Ok|Cancel"			/*Open Description Request*/
IF RESULT=0 then  CALL p_exit													/*Call p_exit, when user aborts*/

SAVEPATH																	/*Get actual saving path of ModExplorer*/
stdsavepath=RESULT															/*And save that value for later reset*/
AUTOPLAY																	/*Get actual autoplay setting*/
stdautoplay=RESULT															/*And save that value for later reset*/

PATHREQUEST "Please select a path, where to save the songs!"							/*Open a path-requester*/
IF RESULT="" then Call p_exit														/*Call p_exit, when user aborts*/
modpath=RESULT																/*Save the selected pathname*/

c=0																			/*Check the last character of selected pathname*/
IF RIGHT(modpath,1)="/" then c=1													/*If it is an "/" */
IF RIGHT(modpath,1)=":" then c=1													/*Or an ":"*/
IF c=0 then modpath=modpath"/"													/*Append an "/" to it*/

FILEREQUEST "Please enter path AND name for the playlist!"							/*Ask for a filename for the pls-file*/
IF RESULT="" then CALL p_exit													/*Call p_exit, when user aborts*/
tabelle=RESULT																/*Save filename of pls for later use*/

SAVEPATH modpath															/*Set savingpath for the modules*/
STOP																		/*Stop ModExplorer playing a module*/
AUTOPLAY OFF																/*Disable autoplaying functin of ModExplorer*/
SELECTLIST PLAYLIST															/*Select the playlist*/
LISTENTRIES																	/*Get number of entries of the playlist*/
plentries=RESULT																/*Save that value*/
OPEN(table,tabelle,"W")															/*Open a file to write the AmigaAMP playlist into*/
WRITELN(table,"[playlist]")														/*Write initial playlist info*/
WRITELN(table,"NumberOfEntries="plentries)										/*Write initial playlist info*/

DO t=0 to plentries-1
	SELECTENTRY t															/*Select an entry from the playlist of ModExplorer*/
	OPEN																	/*Download that file*/
	MODNAME																/*Get the name of the file*/
	name=RESULT																/*And save that name for later use*/
	GUIGAUGETITLE "Working: " t+1 "/" plentries										/*Change gauge title*/
	GUIGAUGE 100/plentries*(t+1)												/*Set new value to the gauge*/
	GUICOMMAND  name														/*Add Song name to the Command lists next line*/
	RECORD																	/*Save downloaded file to previously set savepath*/
	WRITELN(table,"File"t+1"="modpath""name)									/*Write entry to the pls-file for AmigaAMP*/
END

WRITELN(table,"Version=2")														/*Write some last infos to the pls-file*/

SYSTEMREQUEST "Script executed successfully! OK"									/*Request the finished execution of the scrit*/
AUTOPLAY stdautoplay															/*Set Autoplay function of ModExplorer to its initial value*/
SAVEPATH stdsavepath															/*Set ModExplorers savepath to its initial value*/
SLEEP OFF																	/*Wake up ModExplorers GUI again*/
GUI CLOSE																	/*Close the ARexx GUI*/
EXIT																			/*Exit the script*/

p_exit:
SYSTEMREQUEST "Script aborted by user" "OK"											/*Confirm users abort*/
AUTOPLAY stdautoplay															/*Set Autoplay function of ModExplorer to its initial value*/
SAVEPATH stdsavepath															/*Set ModExplorers savepath to its initial value*/
SLEEP OFF																	/*Wake up ModExplorers GUI again*/
GUI CLOSE																	/*Close the ARexx GUI*/
EXIT																			/*Exit the script*/